--- linux-2.6.0-test9/drivers/md/md.c	2003-10-25 13:43:16.000000000 -0500
+++ linux-2.6.0-test9-evms/drivers/md/md.c	2003-11-04 10:34:06.000000000 -0600
@@ -1961,6 +1961,9 @@
 	info.state         = 0;
 	if (mddev->in_sync)
 		info.state = (1<<MD_SB_CLEAN);
+	if (test_bit(MD_RECOVERY_RUNNING, &mddev->recovery) &&
+	    !test_bit(MD_RECOVERY_DONE, &mddev->recovery))
+		info.state |= MD_ARRAY_RECOVERY_RUNNING;
 	info.active_disks  = active;
 	info.working_disks = working;
 	info.failed_disks  = failed;
--- linux-2.6.0-test9/include/linux/raid/md_u.h	2003-10-25 13:44:34.000000000 -0500
+++ linux-2.6.0-test9-evms/include/linux/raid/md_u.h	2003-11-04 10:34:25.000000000 -0600
@@ -50,6 +50,10 @@
 	int patchlevel;
 } mdu_version_t;
 
+#define MD_ARRAY_CLEAN			0
+#define MD_ARRAY_ERRORS			1
+#define MD_ARRAY_RECOVERY_RUNNING	2
+
 typedef struct mdu_array_info_s {
 	/*
 	 * Generic constant information
